﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace AutomataTim.AutomataClasses
{
    [Serializable]
    public class Connection
    {
        
        /*[Category("Входное воздействие")]
        [DisplayName("Помеха справа")]
        [Description("Установите в true если переход должен осуществляться при условии, что помеха находится справа относительно машины")]
        public bool IsRight { get; set; }
        [Category("Входное воздействие")]
        [DisplayName("Помеха слева")]
        [Description("Установите в true если переход должен осуществляться при условии, что помеха находится слева относительно машины")]
        public bool IsLeft { get; set; }*/
        
        public InputData Data;

        [Category("Входное воздействие")]
        [DisplayName("Помеха слева преобладает")]
        [Description("Установите в true если переход должен осуществляться при условии, что помеха слева ближе помехи справа")]
        public bool leftcloser { get { return Data.leftcloser; } set { Data.leftcloser = value; } }
        [Category("Входное воздействие")]
        [DisplayName("Помеха спереди")]
        [Description("Установите в true если переход должен осуществляться при условии, что помеха спереди ближе параметра \"Безопасность\"")]
        public bool frontclose { get { return Data.frontclose; } set { Data.frontclose = value; } }

      /*  [Category("Входное воздействие")]
        [DisplayName("Помеха справа")]
        [Description("Установите в true если переход должен осуществляться при условии, что помеха находится справа относительно машины")]
        public bool IsRight { get { return Data.rightwall; } set { Data.rightwall = value; } }
        [Category("Входное воздействие")]
        [DisplayName("Помеха слева")]
        [Description("Установите в true если переход должен осуществляться при условии, что помеха находится справа относительно машины")]
        public bool IsLeft { get { return Data.leftwall; } set { Data.leftwall = value; } }
        */

        

        [Category("Переход")]
        [DisplayName("Из состояния")]
        [Description("Идентификатор исходного состояния автомата")]
        [ReadOnly(true)]
        public int State1Id { get; set; }
        [Category("Переход")]
        [DisplayName("В состояние")]
        [Description("Идентификатор результирующего состояния автомата")]
        public int State2Id { get; set; }
        [Category("Действие")]
        [DisplayName("Действие")]
        public Action action { get; set; }

        /// <summary>
        /// ///////////// ACTION
        /// </summary>

        private Connection() { Data = new InputData(); }

        public static Connection GetConnection(State state1, State state2)
        {
            return new Connection { State1Id = state1.Id, State2Id = state2.Id };
        }




    }
}
