﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace AutomataTim.AutomataClasses
{
    public enum Action { left, right, accelerate, brake};
    [Serializable]
    public class InputData
    {
//       public bool rightwall { get; set; }
//       public bool leftwall { get; set; }
       public bool leftcloser { get; set; }
       public bool frontclose { get; set; }
       

       public override bool Equals(object obj)
       {
           InputData id = obj as InputData;
           if(id != null)
           {
               //return (rightwall == id.rightwall) && (leftwall == id.leftwall);
               return ((leftcloser == id.leftcloser) && (frontclose == id.frontclose));
           }
           return false;
       }

    }
    public class Framework
    {
        public static int stepnum = 0;
        public static InputData indata;
        public static Automata Automata;
        public static Car car;
        public static CarField carfield;
        public static void reset()
        {
            stepnum = 0;
        }
        public static void Step()
        {
            stepnum++;
           // if (carfield == null || car == null || Automata == null)
           //     return;
            indata = car.getInputData(carfield);
            car.Step(Automata.Step(indata), carfield);
            indata = car.getInputData(carfield);
            ///// automat.step
            //car.Step();
        }
    }
}
