﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;


namespace AutomataTim.AutomataClasses
{
    [Serializable]
    public class State
    {
        public int Id { get; set; }
        public Point Coordinates;
        
        public Automata Automata 
        {
            get { return Framework.Automata; }
        }
        

        public Connection AddConnection(State s2)
        {
            Connection newConnection = Connection.GetConnection(this, s2);
            Automata.Connections.Add(newConnection);
            return newConnection;
        }


        public IEnumerable<Connection> GetConnections()
        {
            return (from c in Automata.Connections
                    where c.State1Id == Id
                    select c);
        }
    }
}
